//////////////////////////////////////////////////////////////////////////////////
// :   ;)
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#include "rm.h"
#include "enumerate.h"
#include "scene.h"
#include <stdio.h>
#include <time.h>
#include <mmsystem.h>

//  
D3DVECTOR verts[] = {
	 1.0f,  1.0f, -1.0f,  1.0f, -1.0f, -1.0f,
	-1.0f, -1.0f, -1.0f, -1.0f,  1.0f, -1.0f,
	 1.0f,  1.0f,  1.0f,  1.0f, -1.0f,  1.0f,
	-1.0f, -1.0f,  1.0f, -1.0f,  1.0f,  1.0f };

//  
DWORD face_data[] = {
	4, 0, 1, 2, 3,
//	4, 3, 2, 1, 0,
	4, 7, 6, 5, 4,
	4, 4, 5, 1, 0,
	4, 3, 2, 6, 7,
	4, 4, 0, 3, 7,
	4, 1, 5, 6, 2,
	0};


#define MAX_TRI 6*2*3
VertexTriangle_t v_tri[MAX_TRI];

//    
DWORD tri_data[MAX_TRI] = {
	0,1,2, 2,3,0,
	7,6,5, 5,4,7,
	4,5,1, 1,0,4,
	3,2,6, 6,7,3,
	4,0,3, 3,7,4,
	1,5,6, 6,2,1,
};

//     
D3DVECTOR verts_face[4] = {  1.0f,  1.0f, 0.0f,    1.0f, -1.0f, 0.0f,
	                        -1.0f, -1.0f, 0.0f, -1.0f,  1.0f, 0.0f };
D3DVECTOR normals_face[4] =  { 0.0f, 0.0f, -1.0f,   0.0f, 0.0f, -1.0f,
		                        0.0f, 0.0f, -1.0f,   0.0f, 0.0f, -1.0f };
DWORD face_normal_data[] = { 4, 0, 0, 1, 1, 2, 2, 3, 3, 0 };
D3DCOLOR colors_face[4]={ 
	0xFF7AFC,0x017AFC,0x057A03,0xFD7A02,
};

//   
BOOL build_face( LPDIRECT3DRMMESHBUILDER3 mb )
{
	int i;
	//  
	for ( i=0; i<4; i++ )
	{
		mb->AddVertex(verts_face[i].x,verts_face[i].y,verts_face[i].z);
		mb->AddNormal(normals_face[i].x,normals_face[i].y,normals_face[i].z);
		mb->SetVertexColor(i,colors_face[i]);
	}
	//  
	mb->AddFacesIndexed(0,face_normal_data,0,0);
	//   
	mb->SetColorSource(D3DRMCOLOR_FROMVERTEX);
	//  
	mb->SetQuality(D3DRMRENDER_GOURAUD&(~D3DRMLIGHT_ON)|(D3DRMLIGHT_OFF)); 
   	return TRUE;
}

//  
BOOL build_cube_faces( LPDIRECT3DRMMESHBUILDER3 mb, float angle )
{

	//  
    mb->AddFaces( 16, verts, 0, 0, face_data, NULL );
	//  
	mb->GenerateNormals(angle,
		D3DRMGENERATENORMALS_USECREASEANGLE );

	return TRUE;

}

//    
BOOL build_cube_triangles( LPDIRECT3DRMMESHBUILDER3 mb, float angle )
{
	for ( int i=0; i<MAX_TRI; i++ )
	{
		v_tri[i].type=D3DRMVERTEX_LIST;
		memcpy(&v_tri[i].pos,&verts[tri_data[i]],sizeof(D3DVECTOR));
	}
	//  
    mb->AddTriangles( 0, D3DRMFVF_TYPE | D3DRMFVF_NORMAL, MAX_TRI, (LPVOID) &v_tri );
	//  
	mb->GenerateNormals(angle,
		D3DRMGENERATENORMALS_USECREASEANGLE );
	return TRUE;

}

//  
BOOL GetFace(
	LPDIRECT3DRMMESHBUILDER3 mb,
	int n, LPDIRECT3DRMFACE2* face)
{
    if (n>= mb->GetFaceCount()) return FALSE;
    //  
	IDirect3DRMFaceArray* arr_faces = NULL;
	mb->GetFaces(&arr_faces);
	//  
	IDirect3DRMFace* tmp_face = NULL;
	arr_faces->GetElement(n, &tmp_face);
	tmp_face->QueryInterface(IID_IDirect3DRMFace2,
		(LPVOID *)face);
	DD_RELEASE( tmp_face );
	DD_RELEASE( arr_faces );
	return TRUE;
}

//   
void color_cube_faces( LPDIRECT3DRMMESHBUILDER3 mb )
{
	D3DCOLOR colors[8] ={
		RGBA_MAKE(255,0,0,128),RGBA_MAKE(0,255,0,128),RGBA_MAKE(0,0,255,128),
		RGBA_MAKE(255,255,0,128),RGBA_MAKE(255,0,255,128),RGBA_MAKE(0,255,255,128),
		RGBA_MAKE(32,32,32,128),RGBA_MAKE(255,255,255,128),
	};
	int i;
	LPDIRECT3DRMFACE2 face;

	for ( i=0; i<mb->GetFaceCount(); i++ )
	{
		if ( GetFace(mb,i,&face)==FALSE ) break;
		face->SetColor(colors[i%8]);
		DD_RELEASE( face );
	}
}

//   
BOOL DemoCubes()
{
    LPDIRECT3DRMFRAME3       frame=0;
    LPDIRECT3DRMMESHBUILDER3 builder_faces=0;
	LPDIRECT3DRMMESHBUILDER3 builder_triangles=0;
    LPDIRECT3DRMMESHBUILDER3 builder_clone=0;
	LPDIRECT3DRMMESH mesh=0;
	HRESULT rc;
    
	//    
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, 0.0f, 0.0f, 0.0f );
	//  
	rc=rm_info.rm->CreateMeshBuilder(&builder_faces);
	DD_CHK(rc,_gError);
	// 
	build_cube_faces(builder_faces,DEGREES_0);
	//  
//	builder_faces->SetColor(RGBA_MAKE(255,0,0,255));
	builder_faces->SetQuality(D3DRMFILL_WIREFRAME);
	// 
	ScaleMesh(builder_faces,D3DVAL(10));
	//  
	builder_faces->CreateMesh(&mesh);
	//   
	frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
	DD_RELEASE( frame );
	DD_RELEASE( mesh );
/*
	//    
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, 15.0f, 0.0f, 0.0f );
	//  
    rc=rm_info.rm->CreateMeshBuilder(&builder_triangles);
	DD_CHK(rc,_gError);
	// 
	build_cube_triangles(builder_triangles,DEGREES_0);
	// 
	builder_triangles->SetColor(RGBA_MAKE(0,255,0,128));
	// 
	ScaleMesh(builder_triangles,D3DVAL(10));
	//  
	builder_triangles->CreateMesh(&mesh);
	//   
	frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
	DD_RELEASE( mesh );
	DD_RELEASE( frame );
	DD_RELEASE( builder_triangles );

	//    
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, -15.0f, 0.0f, 0.0f );
	//  
	rc=builder_faces->Clone(0, IID_IDirect3DRMVisual, (LPVOID *)&builder_clone);
	DD_CHK(rc,_gError);
	//  
	color_cube_faces(builder_clone);
	//  
	builder_clone->CreateMesh(&mesh);
	//  
	frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
	DD_RELEASE( frame );
	DD_RELEASE( mesh );
	DD_RELEASE( builder_clone );
	DD_RELEASE( builder_faces );

	//   
	// 
	rc=rm_info.rm->CreateFrame( main_frame, &frame );
	DD_CHK(rc,_gError);
	// 
	frame->SetPosition( main_frame, 0.0f, 10.0f, 55.0f );
	//  
	rc=rm_info.rm->CreateMeshBuilder(&builder_faces);
	DD_CHK(rc,_gError);
	// 
	build_face(builder_faces);
	// 
	builder_faces->Scale(D3DVAL(55),D3DVAL(20),D3DVAL(0));
	//  
	builder_faces->CreateMesh(&mesh);
	//   
	frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
	DD_RELEASE( frame );
	DD_RELEASE( mesh );
	DD_RELEASE( builder_faces );
*/
	return TRUE;

_gError:
	DD_RELEASE( frame );
	DD_RELEASE( builder_clone );
	DD_RELEASE( mesh );
	DD_RELEASE( builder_faces );
	DD_RELEASE( builder_triangles );
	return FALSE;
}
