//////////////////////////////////////////////////////////////////////////////////
// : RM
// :   DD  D3D
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <ddraw.h>
#include "enumerate.h"

Drv_DD_Info_t DDInfo[MAX_DRV_DD];
Drv_D3D_Info_t D3DInfo[MAX_DRV_D3D];

int count_dd=0, count_d3d=0;
DEVMODE devmode;

static LPDIRECTDRAW      dd=0;

static DWORD BPPToDDBD(int bpp)
{
	switch(bpp) 
	{
	case 1:	return DDBD_1;	case 2:	return DDBD_2;
	case 4:	return DDBD_4;	case 8:	return DDBD_8;
	case 16: return DDBD_16; case 24: return DDBD_24;
	case 32: return DDBD_32;	default: return 0;
	}
}

//   
//     ,    
//   bpp: 16,24,32

int CompareModes( const void *arg1, const void *arg2 )
{
	Mode_Info_t* mode1=(Mode_Info_t*)arg1;
	Mode_Info_t* mode2=(Mode_Info_t*)arg2;

	DWORD volume1=mode1->width*mode1->height;
	DWORD volume2=mode2->width*mode2->height;

	if (volume1<volume2) return 1;
	else if (volume1>volume2) return -1;

	if (mode1->bpp<mode2->bpp) return -1;
	else if (mode1->bpp>mode2->bpp) return 1;
	
	return 0;
}

//    

static HRESULT WINAPI enumMode
	( LPDDSURFACEDESC pddsd,
	  VOID* pParentInfo )
{
	LPD3DDEVICEDESC lpDescD3D=(LPD3DDEVICEDESC)pParentInfo;
	int m=D3DInfo[count_d3d].count_modes;
	int size_mem, want_mem;

	if ( m>=MAX_MODE_DD ) return DDENUMRET_OK;

	//   !!!
	if ( pddsd->ddpfPixelFormat.dwRGBBitCount<=8 ) return DDENUMRET_OK;
	//    640x400
	if ( pddsd->dwWidth<640 ) return DDENUMRET_OK;
	//       
	if ( (BPPToDDBD(pddsd->ddpfPixelFormat.dwRGBBitCount) &
		  lpDescD3D->dwDeviceRenderBitDepth)==0 )
             return DDENUMRET_OK;
	//      
	//   
    size_mem=DDInfo[count_dd].HALCaps.dwVidMemFree;
    if ( size_mem==0 )
        size_mem=DDInfo[count_dd].HELCaps.dwVidMemFree;
	//   GDI
	size_mem+=devmode.dmPelsWidth * devmode.dmPelsHeight * (devmode.dmBitsPerPel>>3) ;
	//     
	want_mem=pddsd->lPitch * pddsd->dwHeight * (pddsd->ddpfPixelFormat.dwRGBBitCount >> 3);
	if ( want_mem>size_mem ) return DDENUMRET_OK;

	//  
    memcpy(&D3DInfo[count_d3d].modes[m].desc,pddsd,sizeof(DDSURFACEDESC));
	D3DInfo[count_d3d].modes[m].width  = pddsd->dwWidth;
	D3DInfo[count_d3d].modes[m].height = pddsd->dwHeight;
	D3DInfo[count_d3d].modes[m].bpp    = pddsd->ddpfPixelFormat.dwRGBBitCount;
	
	sprintf(D3DInfo[count_d3d].modes[m].about,"%dx%dx%d",
		pddsd->dwWidth,pddsd->dwHeight,pddsd->ddpfPixelFormat.dwRGBBitCount);

	D3DInfo[count_d3d].count_modes++;

    return DDENUMRET_OK;
}

//    D3D

static HRESULT WINAPI enumDevicesD3D(
	LPGUID lpGuid,
	LPSTR lpDeviceDescription,
	LPSTR lpDeviceName,
	LPD3DDEVICEDESC lpHWDesc,
	LPD3DDEVICEDESC lpHELDesc,
	LPVOID lpContext)
{
	if ( count_d3d>=MAX_DRV_D3D ) return D3DENUMRET_CANCEL;

    memcpy(&D3DInfo[count_d3d].Guid, lpGuid, sizeof(GUID));
    strncpy(D3DInfo[count_d3d].About, lpDeviceDescription, MAX_NAME_DRV);
    strncpy(D3DInfo[count_d3d].Name, lpDeviceName, MAX_NAME_DRV);

	// ?
	if ( lpHWDesc->dcmColorModel )
	{
		D3DInfo[count_d3d].isHardware=1;
		memcpy(&D3DInfo[count_d3d].Desc, lpHWDesc,sizeof(D3DDEVICEDESC));
	}
	else
	{
		D3DInfo[count_d3d].isHardware=0;
		memcpy(&D3DInfo[count_d3d].Desc, lpHELDesc, sizeof(D3DDEVICEDESC));
	}
	D3DInfo[count_d3d].n_dd=*((int*)lpContext);

	// ?
	D3DInfo[count_d3d].isTexture =
		(D3DInfo[count_d3d].Desc.dpcTriCaps.dwTextureCaps
		  & D3DPTEXTURECAPS_PERSPECTIVE) ? TRUE:FALSE;

	// Z ?
    D3DInfo[count_d3d].isZbuffer =
        D3DInfo[count_d3d].Desc.dwDeviceZBufferBitDepth
         ? TRUE:FALSE;

	//  
    D3DInfo[count_d3d].isRGB =
        D3DInfo[count_d3d].Desc.dcmColorModel & D3DCOLOR_RGB
         ? TRUE:FALSE;

	//   
    dd->EnumDisplayModes( 0, NULL, &D3DInfo[count_d3d].Desc, enumMode );
	qsort( &D3DInfo[count_d3d].modes,
			D3DInfo[count_d3d].count_modes, sizeof(Mode_Info_t), CompareModes );

	//  
	for ( int i=0; i<D3DInfo[count_d3d].count_modes; i++ )
    if ( (D3DInfo[count_d3d].modes[i].width==devmode.dmPelsWidth) &&
		 (D3DInfo[count_d3d].modes[i].height==devmode.dmPelsHeight) )
		{
			D3DInfo[count_d3d].n_ptr_mode=i;
			if ( D3DInfo[count_d3d].modes[i].bpp==devmode.dmBitsPerPel )
				{ D3DInfo[count_d3d].n_ptr_mode=i; break; }
		}

	count_d3d++;

	return D3DENUMRET_OK;
}

//   DD

static BOOL WINAPI enumDriversDD
	(	GUID FAR * lpGUID,
		LPSTR lpDriverDesc, 
		LPSTR lpDriverName, 
		LPVOID lpContext)
{
    LPDIRECT3D2       d3d=0;
    HRESULT           rc;
	int n_dd=count_dd;

	if ( count_dd>=MAX_DRV_DD ) return D3DENUMRET_CANCEL;

    //  
    rc = DirectDrawCreate( lpGUID, &dd, NULL );
    if( rc!=DD_OK ) return D3DENUMRET_OK;
	//    
    strncpy(DDInfo[count_dd].Name, lpDriverName, MAX_NAME_DRV);
    strncpy(DDInfo[count_dd].Desc, lpDriverDesc, MAX_NAME_DRV);
	//  
	memset(&DDInfo[count_dd].HALCaps, 0, sizeof(DDCAPS));
	DDInfo[count_dd].HALCaps.dwSize = sizeof(DDCAPS);
	memset(&DDInfo[count_dd].HELCaps, 0, sizeof(DDCAPS));
	DDInfo[count_dd].HELCaps.dwSize = sizeof(DDCAPS);
	dd->GetCaps(&DDInfo[count_dd].HALCaps, &DDInfo[count_dd].HELCaps);
    if( lpGUID ) DDInfo[count_dd].Guid = (*lpGUID);

	//      DD  D3D
	rc = dd->QueryInterface( IID_IDirect3D2, (void**)&d3d );
	if ( rc == DD_OK )
	{
		d3d->EnumDevices( &enumDevicesD3D, (LPVOID)&n_dd );
		d3d->Release();
	}
    dd->Release();

	count_dd++;
    return DDENUMRET_OK;
}


typedef HRESULT(WINAPI * DIRECTDRAWCREATEEX)( GUID*, VOID**, REFIID, IUnknown* );

//   DD  7  

BOOL CheckDDVersion7()
{
	HRESULT rc;
    HINSTANCE DDHinst = 0;
    LPDIRECTDRAW7 dd;
    DIRECTDRAWCREATEEX DirectDrawCreateEx = 0;

	//  dd,     DD v7
	//    
    DDHinst = LoadLibrary( "DDRAW.DLL" );
    if( DDHinst == 0 ) return FALSE;
    DirectDrawCreateEx = (DIRECTDRAWCREATEEX)GetProcAddress( DDHinst,"DirectDrawCreateEx" );
    if( DirectDrawCreateEx==NULL ) return FALSE;
    rc = DirectDrawCreateEx( NULL, (VOID**)&dd, IID_IDirectDraw7, NULL );
    if( rc!=DD_OK ) return FALSE;
    dd->Release();
	return TRUE;
}

	//      DD  D3D

BOOL EmumerateDriversD3D()
{
	HRESULT rc;

	//    DD  D3D 
	//     DD  
	//   D3D    
	// D3D     DD.
	//      
	//  D3D      DD

	devmode.dmSize = sizeof(DEVMODE);
	EnumDisplaySettings( NULL, ENUM_CURRENT_SETTINGS, &devmode );

	memset(&DDInfo,0,sizeof(DDInfo));
	memset(&D3DInfo,0,sizeof(D3DInfo));

	rc = DirectDrawEnumerate(enumDriversDD, 0);
	if ( rc != DD_OK ) return FALSE;

	return TRUE;
}
