//////////////////////////////////////////////////////////////////////////////////
// :  
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 06.2001
//////////////////////////////////////////////////////////////////////////////////
#include "rm.h"
#include "enumerate.h"
#include "scene.h"
#include <stdio.h>
#include <time.h>
#include <mmsystem.h>

void calc_fps()
{
	static char buf_info[256];
	static DWORD start_time=0, count_frames=0;
	static double fps_f, tps_f;
	double tmp_time;

	count_frames++;
	if ( (count_frames%20)==0 )
	{
		tmp_time=(timeGetTime()-start_time)/1000.;
		fps_f=count_frames/tmp_time;
		start_time=timeGetTime();
		count_frames=0;
	}
	HDC hDC;
	rm_info.backsurf->GetDC(&hDC);
	if ( hDC!=0 )
	{
		SetBkColor(hDC, 0);
		SetTextColor(hDC, RGB(0,255,0));
		//SetBkMode(hDC,TRANSPARENT); 
		sprintf(buf_info, "FPS: %3.2f",fps_f);
		TextOut(hDC, 0, 0, buf_info, strlen(buf_info));
		rm_info.backsurf->ReleaseDC(hDC);
	}
}


void ScaleMesh(LPDIRECT3DRMMESHBUILDER3 mesh, D3DVALUE dim)
{
	D3DRMBOX box;
	mesh->GetBox(&box);	
	D3DVALUE sizex = box.max.x - box.min.x;
	D3DVALUE sizey = box.max.y - box.min.y;
	D3DVALUE sizez = box.max.z - box.min.z;
	D3DVALUE largedim = D3DVALUE(0);	
	if ( sizex>largedim ) largedim=sizex;
	if ( sizey>largedim ) largedim=sizey;
	if ( sizez>largedim ) largedim=sizez;	
	D3DVALUE scalefactor = dim/largedim;
	mesh->Scale(scalefactor,scalefactor,scalefactor);
}


void ScaleFrame(LPDIRECT3DRMFRAME3 frame, D3DVALUE dim)
{
    D3DRMBOX box;
    D3DVALUE maxDim;
    
    frame->GetHierarchyBox(&box);
    
    maxDim = box.max.x - box.min.x;
    if (box.max.y - box.min.y > maxDim) 
	maxDim = box.max.y - box.min.y;
    if (box.max.z - box.min.z > maxDim)
	maxDim = box.max.z - box.min.z;
    
    if (maxDim != 0) {
	frame->AddScale(D3DRMCOMBINE_BEFORE, D3DDivide( dim, maxDim),
			D3DDivide(dim, maxDim),
			D3DDivide(dim, maxDim));
    }
   
}


HRESULT NullFrameNames(LPDIRECT3DRMFRAME lpFrame)
{
    LPDIRECT3DRMFRAMEARRAY lpFA;
    LPDIRECT3DRMFRAME lpChild;
    DWORD nChildren, i;
    HRESULT hres;

    if (FAILED(hres = lpFrame->SetName(NULL)))
    {
            return (hres);
    }

    if (FAILED(hres = lpFrame->GetChildren(&lpFA)))
    {
            return (hres);
    }

    nChildren = lpFA->GetSize();
    for (i = 0; i < nChildren; i++)
    {
            if (FAILED(hres = lpFA->GetElement(i, &lpChild)))
            {
                lpFA->Release();
                return (hres);
            }

            if (FAILED(hres = NullFrameNames(lpChild)))
            {
                lpChild->Release();
                lpFA->Release();
                return (hres);
            }

            lpChild->Release();
    }
    lpFA->Release();

    return S_OK;
}

//    
void DeleteNamesFrame(LPDIRECT3DRMFRAME3 frame)
{
	LPDIRECT3DRMFRAME frame_tmp=0;

	if ( frame==0 ) return;
	frame->QueryInterface(IID_IDirect3DRMFrame, (LPVOID *)&frame_tmp);
	NullFrameNames(frame_tmp);
	DD_RELEASE( frame_tmp );
}
