//////////////////////////////////////////////////////////////////////////////////
// :     RM
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#include "rm.h"
#include "scene.h"

RM_Info_t rm_info={0,};	

BOOL	InitD3DRM ( HWND hwnd, int full_win, int n_d3d, int n_mode )
{
	HRESULT rc;
	int wid, hei, bpp;
	DDSURFACEDESC desc;

	if ( rm_info.yes_init==TRUE ) return FALSE;

	memset(&rm_info,0,sizeof(rm_info));

	int n_dd=rm_info.ptr_dd=D3DInfo[n_d3d].n_dd;
	rm_info.ptr_d3d=n_d3d;
	rm_info.ptr_mode=n_mode;

	rm_info.hwnd=hwnd;
	rm_info.full_screen=full_win?TRUE:FALSE;
	rm_info.yes_init=FALSE;

	rm_info.guid_dd=&DDInfo[n_dd].Guid;
	rm_info.guid_d3d=&D3DInfo[n_d3d].Guid;

	LPDIRECT3DRM rm_tmp;
	rc=Direct3DRMCreate (&rm_tmp);
	if ( rc!=D3DRM_OK ) return FALSE;
    rc = rm_tmp->QueryInterface(IID_IDirect3DRM3, (LPVOID *)&rm_info.rm);
	if ( rc!=D3DRM_OK ) return FALSE;

	if ( rm_info.full_screen==FALSE )
	{	//  
		//    
		RECT rect_win;
		GetClientRect(hwnd,&rect_win);
		wid=rm_info.width=rect_win.right;
		hei=rm_info.height=rect_win.bottom;
		HDC hdc=GetDC(hwnd);
		rm_info.bpp=GetDeviceCaps(hdc,BITSPIXEL);
		ReleaseDC(hwnd,hdc);

		// DD 
		rc=DirectDrawCreate(rm_info.guid_dd, &rm_info.ddraw, 0);
		DD_CHK(rc,_gError);
		rm_info.ddraw->SetCooperativeLevel( rm_info.hwnd, DDSCL_NORMAL | DDSCL_FPUSETUP );

		memset(&desc,0,sizeof(desc));
		desc.dwSize = sizeof(desc);
		desc.dwFlags = DDSD_CAPS;
		desc.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
		rc=rm_info.ddraw->CreateSurface(&desc,&rm_info.primsurf,0);
		DD_CHK(rc,_gError);

		memset(&desc,0,sizeof(desc));
		desc.dwSize = sizeof(desc);
		desc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
		desc.dwWidth = wid;
		desc.dwHeight = hei;
		desc.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE;
		if ( D3DInfo[n_d3d].isHardware==TRUE )
			desc.ddsCaps.dwCaps |= DDSCAPS_VIDEOMEMORY;
		else
			desc.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;
		rc=rm_info.ddraw->CreateSurface(&desc,&rm_info.backsurf,0);
		DD_CHK(rc,_gError);

		memset(&desc,0,sizeof(desc));
		desc.dwSize = sizeof(DDSURFACEDESC);
		desc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_ZBUFFERBITDEPTH;
		desc.dwWidth = wid;
		desc.dwHeight = hei;
		int bit_z;
		desc.ddsCaps.dwCaps = DDSCAPS_ZBUFFER;
		if ( D3DInfo[n_d3d].isHardware==TRUE )
		{
			int devDepth = D3DInfo[n_d3d].Desc.dwDeviceZBufferBitDepth;
			if (devDepth & DDBD_32)
				bit_z = 32;
			else if (devDepth & DDBD_24)
				bit_z = 24;
			else if (devDepth & DDBD_16)
				bit_z = 16;
			else if (devDepth & DDBD_8)
				bit_z = 8;
			desc.ddsCaps.dwCaps |= DDSCAPS_VIDEOMEMORY;
		}
		else
		{
			bit_z=16;
			desc.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;
		}
    	desc.dwZBufferBitDepth = bit_z;
		rc=rm_info.ddraw->CreateSurface(&desc,&rm_info.zbufsurf,0);
		DD_CHK(rc,_gError);
		rm_info.backsurf->AddAttachedSurface(rm_info.zbufsurf);

		rc=rm_info.ddraw->CreateClipper(NULL,&rm_info.clip,NULL);
		DD_CHK(rc,_gError);
		rm_info.clip->SetHWnd(NULL,hwnd);
		DD_CHK(rc,_gError);
		rc=rm_info.primsurf->SetClipper(rm_info.clip);
		DD_CHK(rc,_gError);

		rc=rm_info.rm->CreateDeviceFromSurface(
			rm_info.guid_d3d, rm_info.ddraw, rm_info.backsurf, 0,
			&rm_info.device);
		DD_CHK(rc,_gError);
	}
	else
	{
		wid=rm_info.width=D3DInfo[ n_d3d ].modes[n_mode].width;
		hei=rm_info.height=D3DInfo[ n_d3d ].modes[n_mode].height;
		bpp=rm_info.bpp=D3DInfo[ n_d3d ].modes[n_mode].bpp;

		ShowCursor(FALSE);
		rc=DirectDrawCreate(rm_info.guid_dd, &rm_info.ddraw, 0);
		DD_CHK(rc,_gError);
		rm_info.ddraw->SetCooperativeLevel( rm_info.hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_FPUSETUP );
		rm_info.ddraw->SetDisplayMode( wid, hei, bpp );

		memset(&desc,0,sizeof(desc));
		desc.dwSize = sizeof(desc);
		desc.dwFlags = DDSD_BACKBUFFERCOUNT | DDSD_CAPS;
		desc.dwBackBufferCount = 1;
		desc.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_3DDEVICE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
		rc=rm_info.ddraw->CreateSurface(&desc,&rm_info.primsurf,0);
		DD_CHK(rc,_gError);

		DDSCAPS ddscaps;
		ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
		rc=rm_info.primsurf->GetAttachedSurface(&ddscaps,&rm_info.backsurf);
		DD_CHK(rc,_gError);

		memset(&desc,0,sizeof(desc));
		desc.dwSize = sizeof(DDSURFACEDESC);
		desc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_ZBUFFERBITDEPTH;
		desc.dwWidth = wid;
		desc.dwHeight = hei;
		int bit_z;
		desc.ddsCaps.dwCaps = DDSCAPS_ZBUFFER;
		if ( D3DInfo[n_d3d].isHardware==TRUE )
		{
			int devDepth = D3DInfo[n_d3d].Desc.dwDeviceZBufferBitDepth;
			if (devDepth & DDBD_32)
				bit_z = 32;
			else if (devDepth & DDBD_24)
				bit_z = 24;
			else if (devDepth & DDBD_16)
				bit_z = 16;
			else if (devDepth & DDBD_8)
				bit_z = 8;
			desc.ddsCaps.dwCaps |= DDSCAPS_VIDEOMEMORY;
		}
		else
		{
			bit_z=16;
			desc.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;
		}
    	desc.dwZBufferBitDepth = bit_z;
		rc=rm_info.ddraw->CreateSurface(&desc,&rm_info.zbufsurf,0);
		DD_CHK(rc,_gError);
		rm_info.backsurf->AddAttachedSurface(rm_info.zbufsurf);

		rc=rm_info.rm->CreateDeviceFromSurface(
			rm_info.guid_d3d, rm_info.ddraw, rm_info.backsurf, 0,
			&rm_info.device);
		DD_CHK(rc,_gError);
	}

	rm_info.device->QueryInterface(IID_IDirect3DRMWinDevice,(void **)&rm_info.win_dev);
	rm_info.device->GetDirect3DDevice2(&rm_info.d3d_dev);

	rm_info.d3d_dev->SetRenderState(
		D3DRENDERSTATE_ANTIALIAS,
		D3DANTIALIAS_SORTINDEPENDENT);

	rm_info.device->SetQuality(D3DRMRENDER_GOURAUD);
	rm_info.device->SetTextureQuality(D3DRMTEXTURE_LINEARMIPLINEAR);
	rm_info.device->SetRenderMode(
		D3DRMRENDERMODE_BLENDEDTRANSPARENCY |
		D3DRMRENDERMODE_VIEWDEPENDENTSPECULAR 
		);

	switch ( rm_info.bpp )
	{
	case 16:
		rm_info.device->SetShades( 32 );
		rm_info.rm->SetDefaultTextureColors( 64 );
		rm_info.rm->SetDefaultTextureShades( 32 );
		rm_info.device->SetDither( TRUE );
		break;
	case 24:
	case 32:
		rm_info.device->SetShades( 256 );
		rm_info.rm->SetDefaultTextureColors( 64 );
		rm_info.rm->SetDefaultTextureShades( 256 );
		rm_info.device->SetDither( FALSE );
		break;
	}

	rc=rm_info.rm->CreateFrame(NULL,&rm_info.scene);
	DD_CHK(rc,_gError);

	rc=rm_info.rm->CreateFrame(rm_info.scene,&rm_info.camera);
	DD_CHK(rc,_gError);

	rc=rm_info.rm->CreateViewport(
		rm_info.device, rm_info.camera, 0,0,
		rm_info.device->GetWidth(), rm_info.device->GetHeight(),
		&rm_info.viewport);
	DD_CHK(rc,_gError);
	rm_info.viewport->SetField(D3DVALUE(1.));

	rc=CreateScene();
	if ( rc!=TRUE ) goto _gError;

	rm_info.active=rm_info.yes_init=TRUE;
	rm_info.minimized=FALSE;

	SetPriorityClass(GetCurrentThread(),REALTIME_PRIORITY_CLASS);
	SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

	return TRUE;

_gError:
	DD_RELEASE ( rm_info.scene );
	DD_RELEASE ( rm_info.camera );
	DD_RELEASE ( rm_info.viewport );
	DD_RELEASE ( rm_info.device );
	DD_RELEASE ( rm_info.d3d_dev );
	DD_RELEASE ( rm_info.win_dev );
	DD_RELEASE ( rm_info.clip );
	DD_RELEASE ( rm_info.zbufsurf );
	DD_RELEASE ( rm_info.backsurf );
	DD_RELEASE ( rm_info.primsurf );
	DD_RELEASE ( rm_info.ddraw );
	DD_RELEASE ( rm_info.rm );
	ShowCursor(TRUE);
	return FALSE;
}


void	DestroyD3DRM()
{
	if ( rm_info.yes_init==FALSE ) return;
	rm_info.yes_init=FALSE;
	DestroyScene();
	DD_RELEASE ( rm_info.scene );
	DD_RELEASE ( rm_info.camera );
	DD_RELEASE ( rm_info.viewport );
	DD_RELEASE ( rm_info.device );
	DD_RELEASE ( rm_info.d3d_dev );
	DD_RELEASE ( rm_info.win_dev );
	DD_RELEASE ( rm_info.clip );
	DD_RELEASE ( rm_info.zbufsurf );
	DD_RELEASE ( rm_info.backsurf );
	DD_RELEASE ( rm_info.primsurf );
	if ( rm_info.full_screen==TRUE ) rm_info.ddraw->RestoreDisplayMode();
	DD_RELEASE ( rm_info.ddraw );
	DD_RELEASE ( rm_info.rm );
	ShowCursor(TRUE);
}



void	ActivateD3DRM(WPARAM wParam)
{
	if ( rm_info.yes_init==FALSE ) return;
	if ( rm_info.full_screen==TRUE ) return;

	if ( rm_info.win_dev!=0 )
		rm_info.win_dev->HandleActivate((WORD)wParam);
}


void	UpdateD3DRM()
{
	if ( rm_info.yes_init==FALSE ) return;
	if ( rm_info.active==FALSE ) return;
	if ( rm_info.minimized==TRUE ) return;
	if ( rm_info.pause==TRUE ) return;

	if ( rm_info.primsurf->IsLost() == DDERR_SURFACELOST ) rm_info.primsurf->Restore();
	if ( rm_info.backsurf->IsLost() == DDERR_SURFACELOST ) rm_info.backsurf->Restore();
	if ( rm_info.zbufsurf->IsLost() == DDERR_SURFACELOST ) rm_info.zbufsurf->Restore();
	rm_info.scene->Move(D3DVALUE(1.0));
	rm_info.viewport->Clear(D3DRMCLEAR_ALL);
	rm_info.viewport->Render( rm_info.scene );
	rm_info.viewport->ForceUpdate(0,0,rm_info.width,rm_info.height);
	rm_info.device->Update();
	//write_debug("%lu\n",rm_info.device->GetTrianglesDrawn());
	UpdateScene();
	if ( rm_info.full_screen==FALSE )
	{
		RECT Window;
		POINT pt;

		GetClientRect(rm_info.hwnd, &Window);
		pt.x = pt.y = 0;
		ClientToScreen(rm_info.hwnd, &pt);
		OffsetRect(&Window, pt.x, pt.y);

		rm_info.primsurf->Blt(&Window, rm_info.backsurf, NULL, DDBLT_WAIT, NULL);
	}
	else
	{
		rm_info.primsurf->Flip(0,DDFLIP_WAIT);
	}

}


void	PaintD3DRM()
{
	if ( rm_info.yes_init==FALSE ) return;
	if ( rm_info.full_screen==TRUE ) return;

	HDC hdc=GetDC(rm_info.hwnd);
	int bpp_ptr=GetDeviceCaps(hdc,BITSPIXEL);
	ReleaseDC(rm_info.hwnd,hdc);

	if ( rm_info.bpp!=bpp_ptr )
	{
		DestroyD3DRM();
		InitD3DRM(rm_info.hwnd, rm_info.full_screen==TRUE?1:0,
			rm_info.ptr_d3d, rm_info.ptr_mode);
	}

	RECT rect;
	if ( GetUpdateRect(rm_info.hwnd,&rect,FALSE)==FALSE ) return;
	if ( rm_info.win_dev!=0 )
	{
		PAINTSTRUCT ps;
		BeginPaint( rm_info.hwnd, &ps );
		rm_info.win_dev->HandlePaint(ps.hdc);
		EndPaint( rm_info.hwnd, &ps );
	}
}


void	SizeD3DRM(WPARAM wParam,LPARAM lParam)
{
	if ( rm_info.yes_init==FALSE ) return;
	if ( rm_info.full_screen==TRUE ) return;

	int w = LOWORD(lParam);
	int h = HIWORD(lParam);

	if ( w==0 || h==0 ) { rm_info.minimized=TRUE; return; }
	else rm_info.minimized=FALSE;
	if ( (w==rm_info.width) && (h==rm_info.height) ) return;

	DestroyD3DRM();
	InitD3DRM(rm_info.hwnd, rm_info.full_screen==TRUE?1:0,
		rm_info.ptr_d3d, rm_info.ptr_mode);

}


BOOL WndProc_D3DRM(
		HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)	//  
	{
		case WM_KEYDOWN:
		{
			switch ( wParam )
			{
			case VK_ESCAPE:
			{
				PostMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			case VK_PAUSE:
			{
				rm_info.pause=TRUE;
				break;
			}
			default: rm_info.pause=FALSE;
			}
			rm_info.keys[wParam] = TRUE;
			break;
		}
		case WM_KEYUP:
		{
			rm_info.keys[wParam] = FALSE;
			break;
		}
        case WM_LBUTTONDOWN:
        case WM_LBUTTONUP:
        case WM_RBUTTONDOWN:
        case WM_RBUTTONUP:
        case WM_MOUSEMOVE:
        {
			static int old_x=-1, old_y=-1;
            rm_info.mou_lbut = (wParam&MK_LBUTTON?TRUE:FALSE);
            rm_info.mou_rbut = (wParam&MK_RBUTTON?TRUE:FALSE);
            rm_info.mou_x = LOWORD(lParam);
            rm_info.mou_y = HIWORD(lParam);
			if ( old_x==-1 ) old_x=rm_info.mou_x;
			if ( old_y==-1 ) old_y=rm_info.mou_y;
			rm_info.delta_x+=rm_info.mou_x-old_x;
			rm_info.delta_y+=rm_info.mou_y-old_y;
			if ( rm_info.full_screen==TRUE )
				SetCursorPos(old_x, old_y);
			else
			{
				old_x=rm_info.mou_x;
				old_y=rm_info.mou_y;
			}
            break;
        }
		default: return FALSE;
	}
	return TRUE;
}