//////////////////////////////////////////////////////////////////////////////////
// : RM
// :     RM
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#ifndef RM_H
#define RM_H

#include <windows.h>
#include <windowsx.h>
#include <d3d.h>
#include <ddraw.h>
#include <d3drm.h>
#include <d3drmwin.h>
#include "debug.h"
#include "enumerate.h"

typedef struct {

	BOOL full_screen; // TRUE -   , FALSE -  
	BOOL yes_init; // TRUE -   
	BOOL active; // TRUE -  
	BOOL minimized; // TRUE -          
	BOOL pause; // TRUE - 

	int ptr_dd; //   DD
	int ptr_d3d; //    D3D
	int ptr_mode; //  

	HWND hwnd; //  
	int width; //   
	int height;
	int bpp;

	GUID* guid_dd; //    DD
	GUID* guid_d3d; //    D3D

	//  
	LPDIRECT3DRM3 rm;
	LPDIRECTDRAWCLIPPER clip;
	LPDIRECT3DRMDEVICE3 device;
	LPDIRECTDRAW ddraw;

	// 
	LPDIRECTDRAWSURFACE primsurf;
	LPDIRECTDRAWSURFACE backsurf;
	LPDIRECTDRAWSURFACE zbufsurf;

	//   
	LPDIRECT3DRMFRAME3 scene;

	// 
	LPDIRECT3DRMFRAME3 camera;
	LPDIRECT3DRMVIEWPORT2 viewport;

	LPDIRECT3DRMWINDEVICE win_dev;
	LPDIRECT3DDEVICE2 d3d_dev;

	BOOL keys[256]; //     
	//    
	BOOL mou_lbut;
	BOOL mou_rbut;
	int mou_x;
	int mou_y;
	int delta_x;
	int delta_y;

} RM_Info_t;

#ifdef _YES_DEBUG_
#define DD_CHK(r,g) { \
	if (r!=DD_OK) \
{ write_debug(" - \"%s\"  - %d\r\n - %s\r\n", __FILE__, __LINE__, ErrorRM(r)); goto g; } }
#else
#define DD_CHK(r,g)
#endif

#define DD_RELEASE(x) { if (x) { x->Release(); x=NULL; } }

extern RM_Info_t rm_info;

BOOL	InitD3DRM(HWND hWnd, int full_win, int n_d3d, int n_mode);
void	ActivateD3DRM(WPARAM wParam);
void	UpdateD3DRM();
void	SizeD3DRM(WPARAM wParam,LPARAM lParam);
void	PaintD3DRM();
void	DestroyD3DRM();
BOOL	WndProc_D3DRM(
		HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

//       
char * ErrorRM
	( HRESULT rc );

#endif

