//////////////////////////////////////////////////////////////////////////////////
// :   
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#include "rm.h"
#include "enumerate.h"
#include "scene.h"
#include <stdio.h>
#include <time.h>
#include <mmsystem.h>
#include <math.h>

//  
int n_scene=0;
//   
LPDIRECT3DRMFRAME3 main_frame=0;

//       
BOOL CreateBoard(void)
{
    LPDIRECT3DRMFRAME3       frame=0;
    LPDIRECT3DRMMESHBUILDER3 builder=0;
	LPDIRECT3DRMMESH mesh=0;
	HRESULT rc;
	int i, j;
	D3DCOLOR color_1, color_2;
    
	//    
	//  
	rc=rm_info.rm->CreateMeshBuilder(&builder);
	DD_CHK(rc,_gError);
	// 
	build_cube_faces(builder,DEGREES_90);
	// 
	builder->Scale(D3DVAL(5),D3DVAL(0.1),D3DVAL(5));
	builder->SetQuality(D3DRMRENDER_PHONG); 

	color_1=RGBA_MAKE(255,255,255,255);
	color_2=RGBA_MAKE(128,128,128,255);

	for ( i=-5; i<=5; i++ )
		for ( j=-5; j<=5; j++ )
		{
			// 
			rc=rm_info.rm->CreateFrame( rm_info.scene, &frame );
			DD_CHK(rc,_gError);
			// 
			frame->SetPosition( rm_info.scene, D3DVAL(10*i), D3DVAL(-10), D3DVAL(10*j) );
			builder->SetColor((j%2+i)%2?color_1:color_2);
			//  
			builder->CreateMesh(&mesh);
			//   
			frame->AddVisual( (LPDIRECT3DRMVISUAL)mesh );
			DD_RELEASE( frame );
			DD_RELEASE( mesh );
		}
	DD_RELEASE( builder );
	return TRUE;

_gError:
	DD_RELEASE( frame );
	DD_RELEASE( builder );
	DD_RELEASE( mesh );
	return FALSE;
}


//  
void	CreateLight()
{
	LPDIRECT3DRMLIGHT slight;
	LPDIRECT3DRMFRAME3 slightframe;

	rm_info.rm->CreateLightRGB(D3DRMLIGHT_AMBIENT,
		D3DVAL(0.3),D3DVAL(0.3),D3DVAL(0.3),&slight);
	rm_info.scene->AddLight(slight);
	DD_RELEASE( slight )

	rm_info.rm->CreateLightRGB(D3DRMLIGHT_DIRECTIONAL,
		D3DVAL(1.0),D3DVAL(1.0),D3DVAL(1.0),&slight);
	rm_info.rm->CreateFrame(rm_info.scene,&slightframe);
	slightframe->SetPosition(rm_info.scene,D3DVAL(0.),D3DVAL(0.),D3DVAL(-100.));
	slightframe->LookAt(rm_info.scene,NULL, D3DRMCONSTRAIN_Z);
	slightframe->AddLight(slight);

	DD_RELEASE( slightframe );
	DD_RELEASE( slight )
}

//  
void AddPath()
{
		//rm_info.rm->AddSearchPath("C:\\Projects\\RM\\mesh");
		//rm_info.rm->AddSearchPath("D:\\dx7\\models");
		//rm_info.rm->AddSearchPath("D:\\dx7\\samples\\Multimedia\\D3DIM\\media");
		//rm_info.rm->AddSearchPath("D:\\dx7\\samples\\Multimedia\\D3DRM\\media");
		rm_info.rm->AddSearchPath("data");
}

//  
BOOL CreateScene()
{
static int first=0;

	if ( first==0 )
	{
		AddPath();
		CreateLight();
		SetCamera();
		//if ( CreateBoard()==FALSE ) return FALSE;
		first=1;
	}

	rm_info.rm->CreateFrame(rm_info.scene, &main_frame);
	
	switch ( n_scene )
	{
	case 0: if ( DemoCubes()==FALSE ) return FALSE; break;
	case 1: if ( DemoShapesRotate()==FALSE ) return FALSE; break;
	case 2: if ( DemoMaterial()==FALSE ) return FALSE; break;
	case 3: if ( DemoTexture()==FALSE ) return FALSE; break;
	}


	return TRUE;
}


//  
void DestroyScene()
{
	rm_info.scene->DeleteVisual(main_frame);
	rm_info.scene->DeleteChild(main_frame);
	DD_RELEASE(main_frame);
}


void UpdateScene()
{
	calc_fps();
	move_camera();
}

