//////////////////////////////////////////////////////////////////////////////////
// : RM
// : 
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#ifndef SCENE_H
#define SCENE_H

#include "rm.h"
#include "enumerate.h"

#define DEGREES_0	D3DVAL(0.0)
#define DEGREES_5	D3DVAL(0.087266)
#define DEGREES_10  D3DVAL(0.174533)
#define DEGREES_15  D3DVAL(0.261799)
#define DEGREES_45  D3DVAL(0.785398)
#define DEGREES_90	D3DVAL(1.57080)
#define DEGREES_180 D3DVAL(3.141592654f)

//   AddTriangles
typedef struct
{
    DWORD type;
    D3DVECTOR pos;
	D3DVECTOR normal;
} VertexTriangle_t;

//    
#define SET_D3DVECTOR(v,xx,yy,zz) { (v).x=(D3DVAL(xx)); (v).y=(D3DVAL(yy)); (v).z=(D3DVAL(zz)); }

// scene.cpp
BOOL CreateScene();
void UpdateScene();
void DestroyScene();

// camera.cpp
//  
void SetCamera();
void move_camera();

// misc.cpp
void ScaleMesh(LPDIRECT3DRMMESHBUILDER3 mesh, D3DVALUE dim);
void calc_fps();
void ScaleFrame(LPDIRECT3DRMFRAME3 frame, D3DVALUE dim);
//    
void DeleteNamesFrame(LPDIRECT3DRMFRAME3 frame);

// scene.cpp
//   
extern LPDIRECT3DRMFRAME3 main_frame;
//  
extern int n_scene;

// cubes.cpp
//   
BOOL DemoCubes();
//   
BOOL build_face( LPDIRECT3DRMMESHBUILDER3 mb );
//  
BOOL build_cube_faces( LPDIRECT3DRMMESHBUILDER3 mb, float angle );
//    
BOOL build_cube_triangles( LPDIRECT3DRMMESHBUILDER3 mb, float angle );

// rotate.cpp
//   : , , 
BOOL DemoShapesRotate();
//     
BOOL build_cone(LPDIRECT3DRMMESHBUILDER3 mb, int max_point);
//  
BOOL build_cylinder(LPDIRECT3DRMMESHBUILDER3 mb, int max_point);
//  
BOOL build_sphere(LPDIRECT3DRMMESHBUILDER3 mb, int max_point_xz, int max_point_y);

// material.cpp
//  
BOOL DemoMaterial();

// texture.cpp
//   
BOOL DemoTexture();

#endif

