//////////////////////////////////////////////////////////////////////////////////
// :   Windows
// :  .. anis@pmg-ru.narod.ru
// : 1.00
// : 05.2001
//////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include "rm.h"
#include "resource.h"

//  
int st_full=1, st_win=0, st_next=0, n_d3d=-1, n_mode=-1;

LRESULT CALLBACK WndProc(
				HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)	//  
	{
		case WM_CREATE:
		{
			if ( InitD3DRM(hWnd,st_full,n_d3d,n_mode)==0 )
				SendMessage(hWnd,WM_CLOSE,0,0);
			break;
		}
		case WM_CLOSE:
		{
			DestroyWindow(hWnd);
			break;
		}
		case WM_DESTROY:
		{
			DestroyD3DRM();
			//   
			char *	err=get_last_debug();
			if ( err!=0 ) 
				MessageBox(0,err,"",MB_OK|MB_ICONERROR);
			PostQuitMessage(0);
			break;
		}
		case WM_SIZE:
		{
			SizeD3DRM(wParam,lParam);
			break;
		}
		case WM_ACTIVATE:
		{
			ActivateD3DRM(wParam);
			break;
		}
		case WM_PAINT:
		{
			PaintD3DRM();
			break;
		}
		case WM_ACTIVATEAPP:
		{
			rm_info.active=(BOOL)wParam;
			if ( rm_info.full_screen==TRUE )
			{
				if ( rm_info.active==TRUE ) ShowCursor(FALSE);
				else ShowCursor(TRUE);
			}
			break;
		}
		default:
		{
			if ( WndProc_D3DRM(hWnd,message,wParam,lParam)==TRUE ) return 0;
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
	}
	return 0;
}


void start_rm ( HINSTANCE hinstExe )
{
	MSG		msg;	//   Windows
	WNDCLASS	wc; //   Windows    
	HWND		hWnd;//   
	DWORD		dwStyle;
	int wid=640;
	int hei=480;

	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc		= (WNDPROC) WndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hinstExe;
	wc.hIcon			= NULL;
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= "D3DRM WinClass";

	if(!RegisterClass(&wc))
	{
		MessageBox(0,"   .","",MB_OK|MB_ICONERROR);
		return;
	}

	if ( st_full==1 )
	{
		dwStyle=WS_POPUP;
		wid=D3DInfo[n_d3d].modes[n_mode].width;
		hei=D3DInfo[n_d3d].modes[n_mode].height;
	}
	else
	{
		dwStyle=WS_OVERLAPPEDWINDOW;
		wid=devmode.dmPelsWidth;
		hei=devmode.dmPelsHeight;
	}

	hWnd = CreateWindow(
		"D3DRM WinClass",
		" D3DRM",	//   
		dwStyle | WS_CLIPCHILDREN |	WS_CLIPSIBLINGS,
		0, 0,			//    
		wid, hei,		//    
		NULL, NULL, hinstExe, NULL);

	if(!hWnd)
	{
		MessageBox(0,"  .","",MB_OK|MB_ICONERROR); 
		return;
	}

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);
	SetFocus(hWnd);
 
	while (1)
	{
		if ( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) )
		{
			if ( msg.message == WM_QUIT )
			{
				PostQuitMessage(msg.wParam);
				return;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		UpdateD3DRM();
	}

}

static char buf_options[80];

void ReadOptions()
{
	if ( GetPrivateProfileString( "Example D3DRM 02", "Screen", "",
		 buf_options, 80, ".\\rm.ini") > 0)
		sscanf(buf_options, "%d,%d,%d,%d", &st_full, &st_win, &n_d3d, &n_mode);
}

void SaveOptions()
{
	sprintf(buf_options, "%d,%d,%d,%d", st_full, st_win, n_d3d, n_mode);
	WritePrivateProfileString("Example D3DRM 02", "Screen", buf_options, ".\\rm.ini");
}


//   

void SetEnableModes
	(HWND hwnd)
{
	HWND hwnd_modes = GetDlgItem(hwnd, IDC_COMBO_MODES); 
	EnableWindow(hwnd_modes,st_full?TRUE:FALSE);
}

//    	

void SetCheckDevice
	(HWND hwnd)
{
	//   
	SendDlgItemMessage(hwnd, IDC_CHECK_HW , BM_SETCHECK,
		D3DInfo[n_d3d].isHardware==TRUE?1:0, 0);
	SendDlgItemMessage(hwnd, IDC_CHECK_RGB, BM_SETCHECK,
		D3DInfo[n_d3d].isRGB==TRUE?1:0, 0);
	//  
	SendDlgItemMessage(hwnd, IDC_COMBO_MODES, CB_RESETCONTENT, 0, 0);
	for ( int i=0; i<D3DInfo[n_d3d].count_modes; i++ )
		SendDlgItemMessage(hwnd, IDC_COMBO_MODES, CB_ADDSTRING, 0,
		(LPARAM)D3DInfo[n_d3d].modes[i].about );
	SendDlgItemMessage(hwnd, IDC_COMBO_MODES, CB_SETCURSEL, (WPARAM)n_mode, 0 );
}

//     

BOOL DlgInitScreen
	( HWND hwnd, HWND hwndFocus, LPARAM lParam )
{
	ReadOptions();

	SendDlgItemMessage(hwnd, IDC_RADIO_FULL, BM_SETCHECK, st_full, 0);
	SendDlgItemMessage(hwnd, IDC_RADIO_WIN , BM_SETCHECK, st_win , 0);

	if ( n_d3d>=count_d3d ) n_d3d=-1;
	for ( int i=0; i<count_d3d; i++ )
	{
		SendDlgItemMessage(hwnd, IDC_LIST_D3D, CB_ADDSTRING, 0, (LPARAM)D3DInfo[i].Name);
		if ( n_d3d==-1 && D3DInfo[i].isHardware==TRUE ) n_d3d=i;
	}
	SendDlgItemMessage(hwnd, IDC_LIST_D3D, CB_SETCURSEL, (WPARAM)n_d3d, 0 );
	//  
	if ( n_mode>=D3DInfo[n_d3d].count_modes ) n_mode=-1;
	if ( n_mode==-1 )
		n_mode=D3DInfo[n_d3d].n_ptr_mode;
	SetCheckDevice(hwnd);
	SetEnableModes(hwnd);

	return TRUE;
}

//      

void	DlgCommandScreen
	( HWND hwnd, int id, HWND hwndCtl, UINT codeNotify )
{
	switch ( id )
	{
	case IDC_NEXT :
	{
		st_full=SendDlgItemMessage(hwnd, IDC_RADIO_FULL, BM_GETCHECK, 0, 0);
		st_win =SendDlgItemMessage(hwnd, IDC_RADIO_WIN , BM_GETCHECK, 0, 0);
		n_d3d  =SendDlgItemMessage(hwnd, IDC_LIST_D3D,   CB_GETCURSEL, 0, 0 );
		n_mode =SendDlgItemMessage(hwnd, IDC_COMBO_MODES,CB_GETCURSEL, 0, 0 );
		st_next=1;
		SaveOptions();
		EndDialog(hwnd,id);
		break;
	}
	case IDC_QUIT :
	{
		st_next=0;
		EndDialog(hwnd,id);
		break;
	}
	case IDC_RADIO_FULL:
	{
		st_full=SendDlgItemMessage(hwnd, IDC_RADIO_FULL, BM_GETCHECK, 0, 0);
		st_win=0;
		SetEnableModes(hwnd);
		break;
	}
	case IDC_RADIO_WIN:
	{
		st_win=SendDlgItemMessage(hwnd, IDC_RADIO_WIN, BM_GETCHECK, 0, 0);
		st_full=0;
		SetEnableModes(hwnd);
		break;
	}
	case IDC_LIST_D3D:
	{
		n_d3d=SendDlgItemMessage(hwnd, IDC_LIST_D3D, CB_GETCURSEL, 0, 0);
		//  
		n_mode=D3DInfo[n_d3d].n_ptr_mode;
		SetCheckDevice(hwnd);
		break;
	}
	}
}

//      

BOOL	CALLBACK	DlgProcScreen
	( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	BOOL rc=TRUE;

	switch ( uMsg )
	{
		HANDLE_MSG ( hDlg, WM_INITDIALOG, DlgInitScreen );
		HANDLE_MSG ( hDlg, WM_COMMAND, DlgCommandScreen );
	default:
		rc=FALSE;
		break;
	}
	return rc;
}

	//  

int	WINAPI WinMain
	( HINSTANCE hinstExe, HINSTANCE hinstPrev,
	LPSTR lpszCmdLine, int nCmdShow )
{

	//  
	if ( CheckDDVersion7()==FALSE )
	{
		MessageBox(0," DirectX  7  .","",MB_OK|MB_ICONERROR); 
		return 1;
	}

	//  D3D
	if ( EmumerateDriversD3D()==FALSE )
	{
		MessageBox(0,"  .","",MB_OK|MB_ICONERROR); 
		return 1;
	}

	//       
	// 
	DialogBox ( hinstExe, MAKEINTRESOURCE(IDD_SCREEN), NULL, DlgProcScreen);

	//  RM
	if ( st_next==1 ) start_rm(hinstExe);

	return 0;
}
